<template>
  <AppForm class="form" :form="form" @submit="loginExecute()">
    <Message class="my-5" v-if="errorAlertMessage" severity="error">
      {{ errorAlertMessage }}
    </Message>

    <PrimeFormControlFloat>
      <PrimeFormInputTextFloat
        v-model="email"
        name="email"
        rules="required"
        label="Введите E-mail"
        w-full
        variant="on"
      />
    </PrimeFormControlFloat>
    <PrimeFormControlFloat>
      <PrimeFormInputTextFloat
        v-model="password"
        name="password"
        rules="required"
        label="Введите пароль"
        type="password"
        w-full
        variant="on"
      />
    </PrimeFormControlFloat>

    <PrimeButton
      type="submit"
      class="mt-2"
      label="Войти"
      wFull
      :loading="loginLoading"
    />

    <div class="flex justify-between mt-5">
      <span>Еще нет аккаунта?</span>
      <NuxtLink class="ml-4" to="/auth/register">
        Создайте новый аккаунт
      </NuxtLink>
    </div>
  </AppForm>
</template>

<script lang="ts" setup>
import Message from 'primevue/message'
import { useForm } from 'vee-validate'
import { useUserStore } from '~/stores/user'

const form = useForm()
const router = useRouter()
const { login } = useUserStore()

const errorAlertMessage: Ref<string | boolean> = ref('')

const email = ref('example@domain.com')
const password = ref('123456')

const {
  execute: loginExecute,
  errorValidate,
  loading: loginLoading
} = await useAsyncDataFetch(() => login(email.value, password.value), {
  immediate: false,
  async beforeFetch() {
    errorAlertMessage.value = false

    const validated = await form.validate()

    return validated.valid
  },
  onResponseError(error) {
    errorAlertMessage.value = error.message

    errorValidate(error, {
      validateRules(rules) {
        console.log(rules)

        form.setErrors({
          email: rules?.email,
          password: rules?.password
        })
      }
    })
  },
  onResponseSuccess(value) {
    router.push('/')
  }
})

definePageMeta({
  layout: 'auth',
  middleware: ['no-auth']
})
</script>

<style lang="scss" scoped>
.form {
  &__social {
    display: flex;
    margin: 1rem 0;
    text-align: center;
    gap: 1rem;
  }
}
</style>
